#include <stdio.h>

void divmod(int x, int y, int &d, int &m)
{
    d = x / y;
    m = x % y;

    if ( m < 0 ) {
        d -= 1;
        m += y;
    }
}

int main()
{
    int x, y;

    while ( scanf(" %d %d", &x, &y) == 2 ) {
        if ( y < 0 ) { x = -x; y = -y; }

        printf("[");
        for ( int i = 0; y > 0; i++ ) {
            int d, m;
            divmod(x, y, d, m);

            printf("%d", d);
            if ( m > 0 ) {
                if ( i == 0 ) printf(";");
                else printf(",");
            }

            x = y;
            y = m;
        }
        printf("]\n");
    }

    return 0;
}
