#include <stdio.h>
#include <string.h>

const int MAX = 100;

int main()
{
    int i, j, k, n, m;
    static bool before[MAX + 1][MAX];
    int order[MAX];

    while ( true ) {
        scanf(" %d %d", &n, &m);
        if ( n == 0 ) break;

        for ( i = 0; i <= n; i++ )
            for ( j = 0; j < n; j++ ) before[i][j] = false;

        for ( i = 0; i < m; i++ ) {
            int x, y;
            scanf(" %d %d", &x, &y);
            before[x - 1][y - 1] = true;
        }

        for ( i = 0; i < n; i++ ) {
            // find task that has no task before
            for ( j = 0; j < n; j++ ) {
                for ( k = 0; k <= n; k++ )  // before[n][j] flags tasks already in order
                    if ( before[k][j] ) break;
                if ( k > n ) break;    // found
            }
            if ( j == n ) break;    // obviously cycle

            order[i] = j;
            for ( k = 0; k < n; k++ ) before[j][k] = false;
            before[n][j] = true;
        }

        if ( i == n ) {
            for ( j = 0; j < n; j++ ) printf("%d ", order[j] + 1);
            printf("\n");
        } else
            printf("No solution.\n");
    }

    return 0;
}

